#include <stdio.h>
#define n 16000
FILE *fp;
float a[n*n];
char h[72][80];
int n1,n2,sm=0;
main(int ac,char **av)
{ int i;
  if(ac<3){ printf("\n\t*** smooth 0 value of fitsfile ***\n");
            printf("\n\tUsage: smooth0 input.fit output.fit\n");
            printf("\n\t if bad_line:  linear insert"); 
      printf("\n\t if bad_block,circel: fill a no_star background block\n\n");
            exit(0); }
  fp=fopen(av[1],"rb");if(!fp){printf("\n\t not found!\n",av[1]);exit(0);}
  fread(h,72,80,fp); sscanf(&h[3][20],"%d",&n1); sscanf(&h[4][20],"%d",&n2);
  fread(a,n1*n2,4,fp); swap4(a,n1*n2*4); fclose(fp);
  work_line(a,n1,n2);
  work_block(a,n1,n2); 
  sprintf(h[70],"COMMENT= ' smooth bad pixel %d points '",sm);
  for(i=0;i<80;i++)if(h[70][i]==0)h[70][i]=32; 
  fp=fopen(av[2],"wb"); fwrite(h,72,80,fp); swap4(a,n1*n2*4); 
                        fwrite(a,n1*n2,4,fp); fclose(fp);
  printf("\nok! %s produced. smooth %d points\n\n",av[2],sm);
}

work_line(a,n1,n2)
float a[n2][n1]; int n1,n2;
{
  int i,j,k; float x;
  int m=4;                          // assume line_high <4
  for(j=1;j<n2-1;j++)for(i=0;i<n1;i++)if(a[j][i]==0.){ 
    if(a[j-1][i]==0.)continue;                        // bottom
    for(k=1;k<m;k++){ if(j+k==n2){ k=m; break; }
                       if(a[j+k][i]!=0.)break; }      // top
    if(k==m)continue;                    sm++;
    x=1./(1+k);
    a[j][i]=a[j-1][i]*(1.-x)+a[j+k][i]*x;
  }
  printf("linear insert: %d points\n",sm);
}

short dd[10000];
work_block(a,n1,n2)
float a[n2][n1]; int n1,n2;
{
  int i,j,k,l,i1,i2,j1,j2,ii,jj;
  int i01,i02;
  float x,s;
  for(i01=0;i01<n1;i01++){
    for(j=k=0;j<n2;j++)if(a[j][i01]!=0.)k++;
    if(k)break;
  }
  for(i02=n1-1;i02>0;i02--){
    for(j=k=0;j<n2;j++)if(a[j][i02]!=0.)k++;
    if(k)break;
  } i02++;
  for(j=0;j<n2-2;j++)for(i=i01;i<i02;i++)if(a[j][i]==0.){
      for(k=i+1;k<i02;k++)if(a[j+2][k]!=0.)break; 
      if(k==i+1)continue;
      i2=k; i1=(k+i)/2.;
      for(j2=j+1;j2<n2;j2++)if(a[j2][i1]!=0.)break;
      printf("BLOCK: X,Y, %4d %4d  size %4d*%4d\n",i,j,i2-i,j2-j); 
      i1=i-4; j1=j-4; i2+=4; j2+=4;
      if(i1<i01)i1=i01; if(i2>=i02-1)i2=i02-1;
      if(j1<0)j1=0;     if(j2>=n2-1)j2=n2-1;
      if(i2-i1>i02/2){ j=j2;   continue; }
      k=i1-i2;  if(i2+k<=i01)k=-k;
      l=0;
      for(jj=j1;jj<=j2;jj++)for(ii=i1;ii<=i2;ii++){
        dd[l++]=a[jj][ii+k]; if(l>9999)l--;
      }
      white_black(dd,1,l,&x,&s); x+=1.*s;
      for(jj=j1;jj<=j2;jj++)for(ii=i1;ii<=i2;ii++)if(a[jj][ii]==0.){
        s=a[jj][ii+k];
        if(s>x)s=x;
        a[jj][ii]=s;
        sm++;
      }
  }
}
